#ifndef ABSTRACTFIELDWIDGET_H
#define ABSTRACTFIELDWIDGET_H

#include <QWidget>
#include <QVariant>
#include <QVBoxLayout>
#include <QToolButton>
#include <QMap>
#include <QMouseEvent>
#include <QDebug>
#define STATE_EMPTY -1
#define STATE_ERROR 0
#define STATE_VALID 1
#define STATE_TODO  2
#define STATE_LENGTH  4


class AbstractFieldWidget : public QWidget
{
    Q_OBJECT

public:
    explicit AbstractFieldWidget(QWidget *parent = 0);
    void setWidget(QWidget * widget);
    void setState(int state);
    int state(){return mCurrentState;}
    QWidget * widget(){return mWidget;}



    //=======To overload
    virtual void setValue(QVariant value)=0;
    virtual QVariant value()=0;
    //==================
public slots:
    void toogleState();



signals:
    void stateChanged();
    void changed();

private:
    QWidget * mWidget;
    int mCurrentState;
};




#endif // ABSTRACTFIELDWIDGET_H
