#include "mailfieldwidget.h"
#include <QDesktopServices>
#include <QUrl>
MailFieldWidget::MailFieldWidget(QWidget *parent) :
        AbstractFieldWidget(parent)
{

    mLineEdit = new QLineEdit;
    QToolButton * openLinkButton = new QToolButton;
    openLinkButton->setIcon(QIcon(":/icons/small/send_mail.png"));
    QHBoxLayout * layout = new QHBoxLayout;
    layout->addWidget(mLineEdit);
    layout->addWidget(openLinkButton);
    QWidget * widget =new QWidget;
    widget->setLayout(layout);
    setWidget(widget);
    connect(openLinkButton,SIGNAL(clicked()),this,SLOT(sendMail()));

}
void MailFieldWidget::setValue(QVariant value)
{
    mLineEdit->setText(value.toString());
}

QVariant MailFieldWidget::value()
{

    return mLineEdit->text();

}
void MailFieldWidget::sendMail()
{

    //mailto:user@foo.com?subject=Test&body=Just a test

    QString path = "mailto:"+value().toString()+"?subject=Test&body=Just a test";
    QDesktopServices::openUrl(QUrl(path));

}
